"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TNSRTCConfigurationBase_1 = require("../base/TNSRTCConfigurationBase");
var TNSRTCBundlePolicy_1 = require("../core/TNSRTCBundlePolicy");
var TNSRTCRtcpMuxPolicy_1 = require("../core/TNSRTCRtcpMuxPolicy");
var TNSRTCIceTransportPolicy_1 = require("../core/TNSRTCIceTransportPolicy");
var TNSRTCSdpSemantics_1 = require("../core/TNSRTCSdpSemantics");
var TNSRTCConfiguration = (function (_super) {
    __extends(TNSRTCConfiguration, _super);
    function TNSRTCConfiguration(options) {
        var _this = _super.call(this, options) || this;
        if (options != null) {
            if (Array.isArray(options.iceServers)) {
                var count = options.iceServers.length;
                var nativeArray = [];
                for (var i = 0; i < count; i++) {
                    var server = options.iceServers[i];
                    nativeArray.push(server.instance);
                }
                _this._configuration = FancyRTCConfiguration.alloc().initWithIceServers(nativeArray);
            }
            else {
                _this._configuration = FancyRTCConfiguration.alloc();
            }
            if (options.bundlePolicy != null) {
                switch (options.bundlePolicy) {
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.BALANCED:
                        _this._configuration.bundlePolicy = 0;
                        break;
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.MAX_BUNDLE:
                        _this._configuration.bundlePolicy = 2;
                        break;
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.MAX_COMPAT:
                        _this._configuration.bundlePolicy = 1;
                        break;
                }
            }
            if (options.iceCandidatePoolSize != null) {
                _this._configuration.iceCandidatePoolSize = options.iceCandidatePoolSize;
            }
            if (options.rtcpMuxPolicy != null) {
                switch (options.rtcpMuxPolicy) {
                    case TNSRTCRtcpMuxPolicy_1.TNSRTCRtcpMuxPolicy.NEGOTIATE:
                        _this._configuration.rtcpMuxPolicy = 0;
                        break;
                    case TNSRTCRtcpMuxPolicy_1.TNSRTCRtcpMuxPolicy.REQUIRE:
                        _this._configuration.rtcpMuxPolicy = 1;
                        break;
                }
            }
            if (options.iceTransportPolicy != null) {
                switch (options.iceTransportPolicy) {
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.ALL:
                        _this._configuration.iceTransportPolicy = 0;
                        break;
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.PUBLIC:
                        _this._configuration.iceTransportPolicy = 1;
                        break;
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.RELAY:
                        _this._configuration.iceTransportPolicy = 2;
                        break;
                }
            }
            if (options.sdpSemantics != null) {
                switch (options.sdpSemantics) {
                    case TNSRTCSdpSemantics_1.TNSRTCSdpSemantics.PLAN_B:
                        _this._configuration.sdpSemantics = 0;
                        break;
                    case TNSRTCSdpSemantics_1.TNSRTCSdpSemantics.UNIFIED_PLAN:
                        _this._configuration.sdpSemantics = 1;
                        break;
                }
            }
            if (options.peerIdentity) {
            }
        }
        else {
            _this._configuration = FancyRTCConfiguration.new();
        }
        return _this;
    }
    Object.defineProperty(TNSRTCConfiguration.prototype, "instance", {
        get: function () {
            return this._configuration;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCConfiguration.prototype, "ios", {
        get: function () {
            return this._configuration.configuration;
        },
        enumerable: true,
        configurable: true
    });
    return TNSRTCConfiguration;
}(TNSRTCConfigurationBase_1.TNSRTCConfigurationBase));
exports.TNSRTCConfiguration = TNSRTCConfiguration;
//# sourceMappingURL=TNSRTCConfiguration.js.map